#!/bin/tclsh
source inc/session.tcl

puts "Content-Type: text/html; charset=utf-8"
puts ""

if {[info exists sid] && [check_session $sid]} {
  puts [subst {
    <!DOCTYPE HTML>
    <html lang="de">
    <head>
      <meta charset="utf-8">
      <meta http-equiv="Content-Type" content="text/html;charset=utf-8">
      <meta http-equiv="X-UA-Compatible" content="IE=edge">
      <meta name="viewport" content="width=device-width, initial-scale=1">
      <meta name="description" content="settings">
      <meta name="author" content="https://github.com/homematic-community/hm_pdetect">
      <meta name="language" content="de, german">
      <!-- Bootstrap core CSS -->
      <link href="css/bootstrap.min.css" rel="stylesheet">
      <!-- Custom styles for this template -->
      <link href="css/custombootstrap.css" rel="stylesheet">
      <link href="css/custom.css" rel="stylesheet">
      <title>HM-pdetect Addon</title>
    </head>
    <body class='body-blu' style="zoom: 1; margin-top: 60px;">
    <div class="navbar navbar-default navbar-fixed-top" role="navigation">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
            <span class="sr-only">Toggle navigation</span>
             <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="#"  target="_blank"><img src="img/logo.png" alt=""> &nbsp;
     &nbsp;</a>
          </div>
       <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav ">
            <li class="active"><a href="index.cgi?sid=$sid">Über</a></li>
            <li><a href="logoutput.cgi?sid=$sid">Logfile</a></li>
            <li><a href="settings.cgi?sid=$sid">Konfiguration</a></li>
          </ul>
          <ul class="nav navbar-nav navbar-right">
            <li><a href="en.index.cgi?sid=$sid">English</a></li>
          </ul>
         </div><!--/.nav-collapse -->
      </div><!-- class="container" -->
    </div><!-- class="navbar ..." -->

    <div class="container center1 col-md-8" id="content">
    <legend>FRITZ!-basierte Anwesenheitserkennung für HomeMatic - hm_pdetect</legend>
    <div class="well well-s">
    <b>Allgemeines</b>
    <p>
    Dieses CCU-Addon erlaubt es eine Anwesenheitserkennung von Personen anhand des WLAN/LAN-Status eines <a href="https://www.avm.de/">AVM FRITZ!</a> Gerätes (z.B. FRITZ!Box, FRITZ!Repeater) innerhalb einer <a href="https://www.homematic.com/">eQ3 HomeMatic</a> Umgebung umzusetzen. Anhand von registrierten MAC- bzw. IP-Adressen von Geräten können diese einzelnen Personen zugeordnet werden. Anhand des WLAN/LAN-Status dieser Geräte (z.B. Smartphones) werden dann Systemvariablen innerhalb einer verbundenen CCU entsprechend gesetzt. Geräte die am Ende der Erkennung als unbekannt zugeordnet werden werden als Gastgeräte identifiziert und entsprechend eine separate Variable gesetzt. Dies erlaubt dann die Identifizierung von Gästen im Haus um so z.B. die Heizung eines Gästzimmers entsprechend an/aus zu schalten. Die jeweils generierten Anwesenheitsvariablen können dann entsprechend in der CCU-Umgebung als normale Systemvariablen ausgewertet werden.
    </p>

    <b>Funktionsumfang</b>
    <p>
    <ul>
    <li>WLAN/LAN-Statusabfrage mehrerer paralleler FRITZ!-Geräten (FRITZ!Box/Repeater)</li>
    <li>Vom Nutzer definierbare Intervallzeit zur regelmäßigen Abfrage von FRITZ!-Geräten</li>
    <li>Möglichkeit für manuellen Aufruf der Abwesenheitserkennung mittels CUxD SystemExec calls</li>
    <li>Unterstützung für FRITZ!Box/Repeater Zugang mit oder ohne Passwort im internen Netzwerk</li>
    <li>Möglichkeit der Remote-Abfrage über https-Zugang zu FRITZ!-Geräten</li>
    <li>Berücksichtigung eines separaten Gastzugang-WLAN</li>
    <li>Nutzergerätedefinitionen anhand der MAC- oder IP-Adresse</li>
    <li>Nutzern können mehrere Geräte für Anwesenheitserkennung zugeordnet werden</li>
    <li>Automatisches Anlegen aller notwendigen CCU-Systemvariablen</li>
    <li>Zusätzliche String- und Enum-Systemvariable zur komfortablen Darstellung des Anwesenheitsstatus aller Nutzer</li>
    <li>Gasterkennung anhand des Auftauchens unbekannter Geräte im Gastzugang-WLAN</li>
    <li>Gasterkennung kann auf gesamte WLAN/LAN-Umgebung ausgedehnt werden</li>
    <li>Web-basierte Konfiguration über CCU-WebUI Zugang</li>
    </ul>
    </p>

    <b>Unterstützte CCU Platformen</b>
    <ul>
      <li><a href="https://www.eq-3.de/produkte/homematic/zentralen-und-gateways/smart-home-zentrale-ccu3.html">HomeMatic CCU3</a> / <a href="https://raspberrymatic.de/">RaspberryMatic</a></li>
      <li><a href="https://www.eq-3.de/produkt-detail-zentralen-und-gateways/items/homematic-zentrale-ccu-2.html">HomeMatic CCU2</a></li>
      <li>HomeMatic CCU1</li>
    </ul>

    <b>Unterstützte FRITZ! Modelle</b>
    <ul>
    <li>Alle Modelle von FRITZ!Box und FRITZ!Repeater ab FRITZ!OS 6</li>
    </ul>

    <b>Konfiguration FRITZ!-Geräte</b>
    <ol>
      <li>Aufrufen der Webkonfiguration des jeweiligen FRITZ!-Gerätes (z.B. <a href="https://fritz.box/">https://fritz.box/</a>)
      <li>Anlegen eines neuen Nutzers unter <i>System->FRITZ!Box-Benutzer->Benutzer hinzufügen</i>
      <ul>
        <li>Beschränken der Rechte des neuen Nutzers auf <i>FRITZ!Box Einstellungen</i>
      </ul>
      <li>Aufrufen der Heimnetz-Anmeldeeinstellungen <i>System->FRITZ!Box-Benutzer->Anmeldung im Heimnetz</i>
      <ul>
        <li>Ändern der Anmeldeeinstellungen auf <i>Anmeldung mit FRITZ!Box-Benuternamen und Kennwort</i>
      </ul>
    </ol>

    <b>Installation als CCU-Addon</b>
    <ol>
      <li>Download des aktuellen Addon-Releases von <a href="https://github.com/homematic-community/hm_pdetect/releases">Github</a></li>
      <li>Installation des Addon-Paketes (<code>hm_pdetect-X.X.tar.gz</code>) mittels WebUI Oberfläche der CCU</li>
      <li>Konfiguration der jeweiligen FRITZ!Box/Repeater (siehe nächster Punkt)</li>
      <li>Konfiguration des Addons über WebUI zugängliche <a href="settings.cgi?sid=$sid">Konfigurationswebseite</a></li>
    </ol>

    <b>Manueller CUxD SystemExec Aufruf</b>
    <p>
    Zusätzlich zum automatischen, intervallbasierten Aufrufen von hm_pdetect ist es auch möglich mittels CUxD-basierter SystemExec Aufrufe (<a href="https://www.cuxd.de/">www.cuxd.de</a>) in der CCU-basierten Programmierumgebung eine Ausführung von hm_pdetect zu bestimmten Zeiten (z.B. bei Außentüröffnung) durchführen zu lassen. Hierzu kann man in HomeMatic-Programmen die folgende beispielhafte Anweisung hinzufügen:<br>

    <p>
    <code>
    dom.GetObject("CUxD.CUX2801001:1.CMD_EXEC").State("/usr/local/addons/hm_pdetect/run.sh &lt;iterations&gt; &lt;waittime&gt; &");
    </code>
    </p>

    Hierbei gilt zu beachten, dass bei &lt;iterations&gt; und &lt;waittime&gt; jeweils die Anzahl der Iterationen und eine gewünschte Wartezeit zwischen den Iterationen hinzugefügt werden kann. Ein Beispiel eines solchen Aufrufen kann sein:<br><br>

    <p>
    <code>
    dom.GetObject("CUxD.CUX2801001:1.CMD_EXEC").State("/usr/local/addons/hm_pdetect/run.sh 5 2 &");
    </code>
    </p>

    Dies wird bei Ausführung dieser Anweisung dann hm_pdetect 5-mal hintereinander aufrufen mit jeweils 2 Sekunden Pause zwischen den Aufrufen.
    </p>

    <b>Support</b>
    <p>
    Bei Problemen/Bugs oder Ideen zur Weiterentwicklung bitte unter dem Github-Projekt ein Ticket <a href="https://github.com/homematic-community/hm_pdetect/issues">erstellen</a>. Für Hilfe bei der Benutzung/Konfiguration des Addons kann man unter folgendem deutschsprachigen Forumbeitrag hilfe suchen: <a href="https://homematic-forum.de/forum/viewtopic.php?f=18&t=23907">hm_pdetect</a>.
    </p>

    <b>Lizenz</b>
    <p>Die Nutzung und Entwicklung des Addons unterliegt der Version 3 der LGPL Open Source Lizenz.</p>

    <b>Authoren</b>
    <p>Copyright (c) 2015-2023 Jens Maus &lt;mail@jens-maus.de&gt;</p>

    <b>Hinweis</b>
    <p>
    Dieses Addon nutzt KnowHow das im Zuge folgender anderer Entwicklungen erarbeitet wurde:
    <ul>
      <li><a href="https://github.com/jollyjinx/homematic">https://github.com/jollyjinx/homematic</a></li>
      <li><a href="https://github.com/max2play/webinterface">https://github.com/max2play/webinterface</a></li>
    </ul>
    </p>

    </div>
    </div>
    </body>
    </html>
  }]
} else {
  puts "not authenticated"
}
